<?php
/*
$Id: epayments.php,v 1.00 2004/08/12 19:57:15 hpdl Exp $

osCommerce, Open Source E-Commerce Solutions
http://www.oscommerce.com

Copyright (c) 2003 osCommerce

Released under the GNU General Public License
*/

class epayments {
var $code, $title, $description, $enabled;


function epayments() {
global $order;

$this->code = 'epayments';
$this->title = MODULE_PAYMENT_EPAYMENTS_TEXT_TITLE;
$this->description = MODULE_PAYMENT_EPAYMENTS_TEXT_DESCRIPTION;
$this->sort_order = MODULE_PAYMENT_EPAYMENTS_SORT_ORDER;
$this->enabled = ((MODULE_PAYMENT_EPAYMENTS_STATUS == 'True') ? true : false);

if ((int)MODULE_PAYMENT_EPAYMENTS_ORDER_STATUS_ID > 0) {
$this->order_status = MODULE_PAYMENT_EPAYMENTS_ORDER_STATUS_ID;
}

if (is_object($order)) $this->update_status();

$this->form_action_url = 'https://www.epayments.hsbc.com.ar/public/ssl/routing.aspx';

}

function update_status() {
global $order;

if ( ($this->enabled == true) && ((int)MODULE_PAYMENT_EPAYMENTS_ZONE > 0) ) {
$check_flag = false;
$check_query = tep_db_query("select zone_id from " . TABLE_ZONES_TO_GEO_ZONES . " where geo_zone_id = '" . MODULE_PAYMENT_EPAYMENTS_ZONE . "' and zone_country_id = '" . $order->billing['country']['id'] . "' order by zone_id");
while ($check = tep_db_fetch_array($check_query)) {
if ($check['zone_id'] < 1) {
$check_flag = true;
break;
} elseif ($check['zone_id'] == $order->billing['zone_id']) {
$check_flag = true;
break;
}
}

if ($check_flag == false) {
$this->enabled = false;
}
}
}

function javascript_validation() {
return false;
}

function selection() {
return array('id' => $this->code,
'module' => $this->title);
}

function pre_confirmation_check() {
return false;
}

function confirmation() {
return false;
}

function process_button() {
global $order, $currencies, $currency;

$my_currency = $currency;
if (!tep_session_is_registered('ordercode')){
	tep_session_register('ordercode');
}


$ordercode = date('dhis').'-'.substr(tep_session_id(), (strlen(tep_session_id()) - 3), strlen(tep_session_id()));

$a = $order->info['total'];
$b = $order->info['shipping_cost'];
$c = $currencies->get_value($my_currency);
$d = $currencies->get_decimal_places($my_currency);
$total = $a * $c;
$precio = number_format($total, $d, '.', ',');

$productos = "Productos de " . STORE_NAME . ": ";

for ($i=0, $n=sizeof($order->products); $i<$n; $i++) {
    $productos .= "<br/>" . "- " .  $order->products[$i]['qty'] . '&nbsp;x ' . $order->products[$i]['name'];
    }

$process_button_string = tep_draw_hidden_field('Currency', 'ARS') .
tep_draw_hidden_field('OrderAmount', $precio) .
tep_draw_hidden_field('UserFirstName', $order->customer['firstname']) .
tep_draw_hidden_field('UserLastName', $order->customer['lastname']) .
tep_draw_hidden_field('UserEmail', $order->customer['email_address']) .
tep_draw_hidden_field('ShopCode', MODULE_PAYMENT_EPAYMENTS_ID) .
tep_draw_hidden_field('OrderCode', $ordercode );

$update_ordercode_query = "INSERT INTO orders_gateway  (orders_id, gateway_id, session_id) VALUES ('', '" . $ordercode . "', '" . tep_session_id() . "');";
$update_ordercode = tep_db_query($update_ordercode_query);


return $process_button_string;
}

function before_process() {
}

function after_process() {

	$update_ordercode_query = "UPDATE orders_gateway SET orders_id = (SELECT max(orders_id) FROM orders) WHERE session_id ='" . tep_session_id() . "' and orders_id=0;";
	$update_ordercode = tep_db_query($update_ordercode_query);
	$update_ordercode_query = "UPDATE orders SET gateway_id = (SELECT gateway_id FROM orders_gateway Where orders_id = (SELECT max(orders_id) FROM orders_gateway WHERE session_id='" . tep_session_id() . "')) where orders_id = (SELECT max(orders_id) FROM orders_gateway WHERE session_id='" . tep_session_id() . "')";
	$update_ordercode = tep_db_query($update_ordercode_query);
	tep_session_unregister('ordercode');
	
return false;
}

function output_error() {
return false;
}

function check() {
if (!isset($this->_check)) {
$check_query = tep_db_query("select configuration_value from " . TABLE_CONFIGURATION . " where configuration_key = 'MODULE_PAYMENT_EPAYMENTS_STATUS'");
$this->_check = tep_db_num_rows($check_query);
}
return $this->_check;
}


function add_column_if_not_exist($db, $column, $column_attr){
  $exists = false;
  $columns = mysql_query("show columns from $db");
  while($c = mysql_fetch_assoc($columns)){
      if($c['Field'] == $column){
          $exists = true;
          break;
      }
    }      
  if(!$exists){
      tep_db_query("ALTER TABLE `$db` ADD `$column`  $column_attr");
  }
}

function install() {
tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Enable epayments Module', 'MODULE_PAYMENT_EPAYMENTS_STATUS', 'True', 'Do you want to accept epayments payments?', '6', '3', 'tep_cfg_select_option(array(\'True\', \'False\'), ', now())");
tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('ShopCode', 'MODULE_PAYMENT_EPAYMENTS_ID', '00001', 'Provisto por el Banco', '6', '4', now())");	
tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Sort order of display.', 'MODULE_PAYMENT_EPAYMENTS_SORT_ORDER', '0', 'Sort order of display. Lowest is displayed first.', '6', '0', now())");

$exists = false;
  $columns = tep_db_query("show columns from orders");
  while($c = mysql_fetch_assoc($columns)){
      if($c['Field'] == 'gateway_id'){
          $exists = true;
          break;
      }
    }      
  if(!$exists){
	tep_db_query("ALTER TABLE orders ADD gateway_id varchar (20)");
	tep_db_query("CREATE TABLE orders_gateway (orders_id INT(11), gateway_id VARCHAR(20), session_id VARCHAR(50))");
	}
}

function remove() {
tep_db_query("delete from " . TABLE_CONFIGURATION . " where configuration_key in ('" . implode("', '", $this->keys()) . "')");
}

function keys() {
return array('MODULE_PAYMENT_EPAYMENTS_STATUS', 'MODULE_PAYMENT_EPAYMENTS_ID',  'MODULE_PAYMENT_EPAYMENTS_SORT_ORDER', );
}
}
?>